﻿using UnityEngine;
using UnityEngine.UI;
using HoloToolkit.Unity;
using Academy.HoloToolkit.Unity;
using UnityEngine.VR.WSA.Input;

public class ButtonBehavior : MonoBehaviour
{
    [Tooltip("Object to insantiate on click")]
    public GameObject respawn;

    [Tooltip("menu(Canvas) object, to hide, when button is clicked.")]
    public GameObject menu;

    private Button btn;

    private void Awake()
    {
        btn = GetComponent<Button>();
    }

    void OnSelect()
    {
        if (GetComponent<Interactible>() != null)
        {
            GetComponent<Interactible>().resetGaze();
        }
        if (MySocket.countScan == 1)
        {
            //MySocket.record = true;
        }
        MySocket.countScan++;
        RealWorldObjectManager.Instance.dismissMenu();
        menu.SetActive(false);
        var location = Camera.main.transform.position;
        var rotation = Camera.main.transform.rotation;
        var newGameObj = Instantiate(respawn, location, rotation);
        newGameObj.GetComponent<ActiveCallBack>().activeOnFinish = menu;
    }

    void GazeEntered()
    {
        btn.Select();
        btn.OnPointerEnter(null);
    }

    void GazeExisted()
    {
        btn.OnDeselect(null);
        btn.OnPointerExit(null);
    }

}