﻿#if UNITY_UWP && !UNITY_EDITOR
using System;
using System.Collections;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
#endif
using HoloToolkit.Unity;
using System;
using System.Collections.Generic;
using UnityEngine;

public class MySocket : MonoBehaviour {

    static string SERVER_IP = "132.68.34.36";
    static string PORT = "20605";
    static string LOGGER_PORT = "20604";
    public static bool record = false;
    public static int countScan = 0;

#if UNITY_UWP && !UNITY_EDITOR
    static Windows.Networking.Sockets.StreamSocket socket;
    static BinaryReader reader;
    static BinaryWriter writer;

#endif
    public static bool isConnected = false;
    static bool isSending = false;
    public static bool isBoxesReady = false;
    public static Dictionary<string, List<DetectedObjectData>> image2Objects
        = new Dictionary<string, List<DetectedObjectData>>();
#if UNITY_UWP && !UNITY_EDITOR
    async
#endif
    public static void initConnection()
    {
        MySocket.log("starting initConnection");
#if UNITY_UWP && !UNITY_EDITOR
        socket = new Windows.Networking.Sockets.StreamSocket();
        Windows.Networking.HostName serverHost = new Windows.Networking.HostName(SERVER_IP);
        string serverPort = PORT;
        await socket.ConnectAsync(serverHost, serverPort);
        MySocket.log("connected !");
        writer = new BinaryWriter(socket.OutputStream.AsStreamForWrite());
        reader = new BinaryReader(socket.InputStream.AsStreamForRead());
        isConnected = true;
#endif
    }

    static bool alwaysTrue = true;

    private static byte[] readMsg()
    {
        byte[] tmp = new byte[4];
#if UNITY_UWP && !UNITY_EDITOR
        
        int msgLen = reader.ReadInt32();
        byte[] msg = reader.ReadBytes(msgLen);
        if (alwaysTrue) {
            return msg;
        }
        
#endif
        return tmp;
    }

    private static void writeMsg(byte[] msg)
    {
#if UNITY_UWP && !UNITY_EDITOR
        
        writer.Write(msg.Length);
        writer.Write(msg);
        writer.Flush();

#endif
    }

    public static void sendFrame(byte[] image, string id, bool isLast)
    {
        if (isSending) return;
        isSending = true;
#if UNITY_UWP && !UNITY_EDITOR
        string base64ImageRepresentation = Convert.ToBase64String(image);
        string msg = Newtonsoft.Json.JsonConvert.SerializeObject(new
        {
            image_file = image,
            id = id,
            opcode = "SCAN",
            last = isLast
        });
        UTF8Encoding Encoding = new UTF8Encoding();
        writeMsg(Encoding.GetBytes(msg));
#endif
        isSending = false;
    }

    public static void sendFrameForTracker(byte[] image, string id)
    {
        if (isSending) return;
        isSending = true;
#if UNITY_UWP && !UNITY_EDITOR
        string base64ImageRepresentation = Convert.ToBase64String(image);
        string msg = Newtonsoft.Json.JsonConvert.SerializeObject(new
        {
            image_file = image,
            id = id,
            opcode = "TRACK"
        });
        UTF8Encoding Encoding = new UTF8Encoding();
        writeMsg(Encoding.GetBytes(msg));
#endif
        isSending = false;
    }

    public static void sendFrameForTracker(byte[] image, string id, Vector2 pos)
    {
        if (isSending) return;
        isSending = true;
#if UNITY_UWP && !UNITY_EDITOR
        string base64ImageRepresentation = Convert.ToBase64String(image);
        string msg = Newtonsoft.Json.JsonConvert.SerializeObject(new
        {
            image_file = image,
            id = id,
            opcode = "TRACK",
            x = (int)pos.x,
            y = (int)pos.y
        });
        UTF8Encoding Encoding = new UTF8Encoding();
        writeMsg(Encoding.GetBytes(msg));
#endif
        isSending = false;
    }

    public static Vector2 readBoundBox()
    {
#if UNITY_UWP && !UNITY_EDITOR
        byte[] msgInBytes = readMsg();
        UTF8Encoding Encoding = new UTF8Encoding();
        string msg = Encoding.GetString(msgInBytes);
#endif
        Dictionary<string, string> dict = null;
#if UNITY_UWP && !UNITY_EDITOR
        dict = Newtonsoft.Json.JsonConvert.DeserializeObject<Dictionary<string, string>>(msg); 
#endif
        log("Boxes: " + dict.Keys.Count.ToString());
        Vector2 pos = new Vector2
        {
            x = float.Parse(dict["x"]),
            y = float.Parse(dict["y"])
        };
        return pos;
    }
    public static void clearReadBoxes()
    {
        image2Objects = new Dictionary<string, List<DetectedObjectData>>();
        isBoxesReady = false;
    }
    public static void readBoxes()
    {
#if UNITY_UWP && !UNITY_EDITOR
        byte[] msgInBytes = readMsg();
        UTF8Encoding Encoding = new UTF8Encoding();
        string msg = Encoding.GetString(msgInBytes);
#endif
        // log("Boxes recieved !");
        Dictionary<string, List<List<string>>> dict = null;
#if UNITY_UWP && !UNITY_EDITOR
        dict = Newtonsoft.Json.JsonConvert.DeserializeObject<Dictionary<string, List<List<string>>>>(msg); 
#endif
        log("Boxes: " + dict.Keys.Count.ToString());
        foreach (string image_id in dict.Keys)
        {
            log("for image : " + image_id + " : " + dict[image_id].Count.ToString());
            var lst = new List<DetectedObjectData>();
            foreach (List<string> box in dict[image_id])
            {
                try
                {
                    float x;
                    int y;
                    if (box.Count < 4 || !float.TryParse(box[0], out x) || !float.TryParse(box[1], out x)
                        || !int.TryParse(box[3], out y))
                    {
                        MySocket.log("wrong box format");
                    }
                    lst.Add(new DetectedObjectData()
                    {
                        objectPos = new Vector2(float.Parse(box[0]), float.Parse(box[1])),
                        label = box[2],
                        score = int.Parse(box[3])
                    });
                } catch (Exception e)
                {
                    log("cant parse number");
                }
                
            }
            log("got box loop");
            image2Objects.Add(image_id, lst);
        }
        log("got box outer loop");
        string answer = "";
        foreach (string image_id in image2Objects.Keys)
        {
            answer += "; " + image_id + ": ";
            foreach (var obj in image2Objects[image_id])
            {
                answer += obj.objectPos.ToString() + " with label : " + obj.label;
            }
        }
        //log("Boxes READY :" + answer);
        isBoxesReady = true;
        log("now my boxes ready  is : " + MySocket.isBoxesReady.ToString());
    }

    public static Vector2 resultPos = Vector2.zero;
    public static bool isPositionReady = false;
    public static bool ignore = false;

    public static void processTrackImage(byte[] imageBuffer, string imageId)
    {
        MySocket.sendFrameForTracker(imageBuffer, imageId);
        resultPos = MySocket.readBoundBox();
        //MySocket.log("Finished task");
        if (ignore)
        {
            return;
        }
        isPositionReady = true;
    }

    public static void UploadFirstImage(byte[] imageBuffer, string imageId, Vector2 pixelPos)
    {
        MySocket.sendFrameForTracker(imageBuffer, imageId, pixelPos);
        resultPos = MySocket.readBoundBox();
        //MySocket.log("Finished task");
        if (ignore)
        {
            return;
        }
        isPositionReady = true;
    }


#if UNITY_UWP && !UNITY_EDITOR
    async
#endif
    public static void log(string msg)
    {
#if UNITY_UWP && !UNITY_EDITOR
        UTF8Encoding Encoding = new UTF8Encoding();
        Windows.Networking.Sockets.StreamSocket socket = new Windows.Networking.Sockets.StreamSocket();
        Windows.Networking.HostName serverHost = new Windows.Networking.HostName(SERVER_IP);
        string serverPort = LOGGER_PORT;
        await socket.ConnectAsync(serverHost, serverPort);
        Stream streamOut = socket.OutputStream.AsStreamForWrite();
        BinaryWriter writer = new BinaryWriter(streamOut);
        writer.Write(msg);
        writer.Flush();
        socket.Dispose();
#endif
    }

    public static void closeConnection()
    {
#if UNITY_UWP && !UNITY_EDITOR
        socket.Dispose();
#endif
    }
}