﻿using HoloToolkit.Unity;
using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class ScannerInteraction : MonoBehaviour {

    // Use this for initialization
    PhotoCaptureMgr photoMgr;
    TextToSpeech textToSpeech;
    ScannerState state;

    public AudioClip backgroundMusic;

    enum ScannerState {
        Intro, Playing
    };

    void Start () {
        state = ScannerState.Intro;
    }

    private void Awake()
    {
        photoMgr = GetComponent<PhotoCaptureMgr>();
        textToSpeech = GetComponent<TextToSpeech>();
    }

    // Update is called once per frame
    bool startedPlaying = false;

    void Update () {

        if (state == ScannerState.Intro)
        {
            StartCoroutine(Speak("Please walkthrough the room, say Take Photo to scan the objects" +
                "  you want to find later, or say Change if you want to scan by gazing.", () => {

                    photoMgr.StartCapturing();
                    this.GetComponent<AudioSource>().PlayClip(backgroundMusic, true);

                }));
            state = ScannerState.Playing;
        }
	}

    public void stopSound()
    {
        AudioSource src = this.GetComponent<AudioSource>();
        src.loop = false;
        src.Stop();
    }

    public void startSound()
    {
        this.GetComponent<AudioSource>().PlayClip(backgroundMusic, true);
    }

    public IEnumerator Speak(string msg, Action act)
    {
        yield return new WaitUntil(() => textToSpeech.IsSpeaking() == false);
        textToSpeech.StartSpeaking(msg);
        yield return new WaitUntil(() => textToSpeech.IsSpeaking() == true);
        yield return new WaitUntil(() => textToSpeech.IsSpeaking() == false);
        act();    
    }

    public bool isSpeaking()
    {
        return textToSpeech.IsSpeaking();
    }

    void onObjectsMapped()
    {
        /*
        textToSpeech.StartSpeaking("Data processing completed, objects were detected.");
        var comp = GetComponent<ActiveCallBack>();
        MySocket.log("at least comp isnt null" + (comp != null).ToString());
        MySocket.log("at least object on comp isnt null" + (comp.activeOnFinish != null).ToString());
        comp.activeOnFinish.SetActive(true); */
        // Destroy(gameObject);
        MySocket.log("start speaking");
        StartCoroutine(Speak("Data processing completed, objects were detected.", () => {
            MySocket.log("inside speak");
            GetComponent<ActiveCallBack>().activeOnFinish.SetActive(true);
            Destroy(gameObject);
            MySocket.log("destroyed");
        }));
    }

    void onScanFinished()
    {
        StartCoroutine(Speak("Scanning is finished, please wait untill data is processed.", () => {
            MySocket.log("scan is finished");
        }));
    }
}
