﻿using System.Collections.Generic;
using System.Linq;
using UnityEngine;
using UnityEngine.Windows.Speech;

public class SpeechManager : MonoBehaviour
{
    KeywordRecognizer keywordRecognizer = null;

    string command = "Find";

    bool isOn = false;

    int frameCounter = 0;

    // Use this for initialization
    void Start()
    {

    }

    void Update()
    {
        /* frameCounter++;
        if (isOn && frameCounter % 60 == 0 && !keywordRecognizer.IsRunning)
        {
            frameCounter = 0;
            keywordRecognizer.Start();
        } */
    }

    private void StartRecognize(List<string> objects)
    {
        StopRecognize();
        var keywords = objects.Select(s => command + " " + s).ToArray();
        keywordRecognizer = new KeywordRecognizer(keywords);
        keywordRecognizer.OnPhraseRecognized += KeywordRecognizer_OnPhraseRecognized;
        keywordRecognizer.Start();
        isOn = true;
        MySocket.log("Start recognizing");
    }

    private void StopRecognize()
    {
        if (keywordRecognizer != null && keywordRecognizer.IsRunning)
        {
            keywordRecognizer.Stop();
        }
        isOn = false;
        MySocket.log("Stop recognizing");
    }

    private void KeywordRecognizer_OnPhraseRecognized(PhraseRecognizedEventArgs args)
    {
        MySocket.log(args.text);
        SendMessage("OnObjectRequest", args.text.Remove(0, (command + " ").Length));
    }
}