﻿using Academy.HoloToolkit.Unity;
using HoloToolkit.Unity;
using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.Windows.Speech;

public class WorldObjectsView : MonoBehaviour {

    // Use this for initialization
    TextToSpeech textToSpeech;
    KeywordRecognizer keywordRecognizer = null;
    MicrophoneManager micMgr;
    State currentState;

    enum State
    {
        Wake, Play
    };

    void Start () {
        currentState = State.Wake;
        RealWorldObjectManager.Instance.showWorldObjects();
    }

    private void Awake()
    {
        textToSpeech = GetComponent<TextToSpeech>();
        micMgr = GetComponent<MicrophoneManager>();
    }

    private void phraseRecognized(PhraseRecognizedEventArgs args)
    {
        if (args.text == "Back")
        {
            goBack();
        }
    }

    private void gotItemName(string text)
    {
        MySocket.log("Got this item :" + text);
        Vector3 pos = GazeManager.Instance.SpatialMappingRay();
        var newobj = RealWorldObjectManager.Instance.addObject(positions.Average(), text, new Vector3(0.015f, 0, -0.01f));
        RealWorldObjectManager.Instance.showWorldObject(newobj, false);
        RealWorldObjectManager.Instance.writeObjectsToDisk();
    }

    private void goBack()
    {
        micMgr.StopRecording();
        GetComponent<ActiveCallBack>().activeOnFinish.SetActive(true);
        RealWorldObjectManager.Instance.hideWorldObjects();
        Destroy(gameObject);
    }

    IEnumerator Speak(string msg, Action act)
    {
        textToSpeech.StartSpeaking(msg);
        yield return new WaitUntil(() => textToSpeech.IsSpeaking() == true);
        yield return new WaitUntil(() => textToSpeech.IsSpeaking() == false);
        act();
    }

    List<Vector3> positions = new List<Vector3>();
    int maxGazesSize = 60;

    // Update is called once per frame
    void Update () {

        if (currentState == State.Wake)
        {
            StartCoroutine(Speak("Walk through the room to see the objects, say Back to go the main menu"
            , () => {}));
            micMgr.StartRecording();
            currentState = State.Play;
        }
        if (GazeManager.Instance.SpatialMappingHit)
        {
            positions.Add(GazeManager.Instance.SpatialMappingPosition);
            if (positions.Count > maxGazesSize)
            {
                positions.RemoveAt(0);
            } 
        }
	}
}
