from collections import defaultdict
from object_detection import ObjectDetection

class ImageManager:

    def __init__(self):
        self.detected_objects = defaultdict(list)
        self.frames = []
        self.model = None

    def add_frame(self, frame):
        self.frames.append(frame)

    def process_images(self):
        if self.model is None:
            self.model = ObjectDetection()
        self.model.run(self.frames)
